#include <stdio.h>
#include <math.h>

#define	HYPER_DIST_FACTOR	200.0
#define	HYPER_DRIVE_FUEL_USE	5.0

extern char	*optarg;

char		*progname = "fuse";

main(ac, av)
int	ac;
char	**av;
{
	int	c;
	char	*p;
	double	tech;
	double	mass;
	double	fuse;
	double	dist;
	double	distfac;
	int	x;

	tech = 50.0;
	mass = 10.0;
	while ((c = getopt(ac, av, "m:t:")) > 0) {
		switch (c) {
			case 'm':
				mass = strtod(optarg, &p) ;
				if ((optarg == p) || (mass <= 0.0) ||
						(*p != '\0')) {
					fprintf(stderr,
						"%s: invalid mass %s\n",
						progname, optarg);
					usage();
					exit(-1);
				}
				break;
			case 't':
				tech = strtod(optarg, &p) ;
				if ((optarg == p) || (tech <= 0.0) ||
						(*p != '\0')) {
					fprintf(stderr,
						"%s: invalid tech-level %s\n",
						progname, optarg);
					usage();
					exit(-1);
				}
				break;
			default:
				usage();
				exit(-1);
		}
	}

	printf("YUnitText: Distance\n");
	printf("XUnitText: Fuel Usage\n");
	printf("TitleText: Tech %G, Mass %G\n", tech, mass);
	distfac = HYPER_DIST_FACTOR * (tech + 100.0);
	for (x = 0; x <= 1; x++) {
		printf("\"Crystal %sMounted\"\n", x ? "" : "Not ");
		printf("move ");
		for (dist = 20000.0; dist < 200000.0; dist += 10000.0) {
			if (x && dist > distfac)
				fuse = HYPER_DRIVE_FUEL_USE * sqrt(mass) * (dist / distfac);
			else
				fuse = HYPER_DRIVE_FUEL_USE * sqrt(mass) * (dist / distfac) * (dist / distfac);
			printf("%lf %lf\n", fuse, dist);
		}
		printf("\n");
	}

	exit(0);
}

usage() {
	fprintf(stderr, "Usage: %s [-m mass] [-t tech-level]\n",
		progname);
}
